package fr.uca.iut.clfreville2.model.sensor.auto;

import fr.uca.iut.clfreville2.model.sensor.AutoSensor;
import fr.uca.iut.clfreville2.model.sensor.auto.factory.AutoUpdateStrategyFactory;
import fr.uca.iut.clfreville2.model.sensor.auto.factory.StandardUpdateStrategyFactory;

import java.util.Random;

public class RandomUpdateStrategy implements AutoUpdateStrategy {

    private final Random random;
    private final int min;
    private final int max;

    public RandomUpdateStrategy(int min, int max) {
        this(new Random(), min, max);
    }

    public RandomUpdateStrategy(Random random, int min, int max) {
        this.random = random;
        this.min = min;
        this.max = max;
    }

    @Override
    public double nextValue(AutoSensor currentState) {
        return random.nextDouble(min, max);
    }

    @Override
    public AutoUpdateStrategyFactory getType() {
        return StandardUpdateStrategyFactory.RANDOM_UPDATE;
    }
}
